#
# Copyright 2004 Eugene Gershnik
#
# Use of this source code is governed by a BSD-style
# license that can be found in the LICENSE file or at
# https://github.com/gershnik/intrusive_shared_ptr/blob/master/LICENSE.txt
#


####### Expanded from @PACKAGE_INIT@ by configure_package_config_file() #######
####### Any changes to this file will be overwritten by the next CMake run ####
####### The input file was isptr-config.cmake.in                            ########

get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../../../" ABSOLUTE)

# Use original install prefix when loaded through a "/usr move"
# cross-prefix symbolic link such as /lib -> /usr/lib.
get_filename_component(_realCurr "${CMAKE_CURRENT_LIST_DIR}" REALPATH)
get_filename_component(_realOrig "/usr/lib/i386-linux-gnu/isptr" REALPATH)
if(_realCurr STREQUAL _realOrig)
  set(PACKAGE_PREFIX_DIR "/usr")
endif()
unset(_realOrig)
unset(_realCurr)

macro(set_and_check _var _file)
  set(${_var} "${_file}")
  if(NOT EXISTS "${_file}")
    message(FATAL_ERROR "File or directory ${_file} referenced by variable ${_var} does not exist !")
  endif()
endmacro()

macro(check_required_components _NAME)
  foreach(comp ${${_NAME}_FIND_COMPONENTS})
    if(NOT ${_NAME}_${comp}_FOUND)
      if(${_NAME}_FIND_REQUIRED_${comp})
        set(${_NAME}_FOUND FALSE)
      endif()
    endif()
  endforeach()
endmacro()

####################################################################################


# Avoid repeatedly including the targets
if(NOT TARGET isptr::isptr)
    include(${CMAKE_CURRENT_LIST_DIR}/isptr-exports.cmake)
endif()

if(ISPTR_PROVIDE_MODULE)
    if(NOT TARGET isptrm::isptrm)
        include(${CMAKE_CURRENT_LIST_DIR}/isptrm-exports.cmake)

        if(ISPTR_ENABLE_PYTHON AND NOT Python3_Development_FOUND)
            find_package (Python3 COMPONENTS Development REQUIRED)
        endif()

        add_library(isptrm_helper INTERFACE)
        add_library(isptrm::helper ALIAS isptrm_helper)

        if (ISPTR_ENABLE_PYTHON)

            target_include_directories(isptrm_helper SYSTEM
            INTERFACE
                ${Python3_INCLUDE_DIRS}
            )

            target_link_libraries(isptrm_helper
            INTERFACE
                ${Python3_LIBRARIES}
            )

            target_compile_definitions(isptrm_helper 
            INTERFACE
                ISPTR_ENABLE_PYTHON=1
            )
        endif()

        target_link_libraries(isptrm::isptrm
        INTERFACE
            isptrm::helper
        )
    endif()
endif()

